﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace PedestrianProblem
{
    class Program
    {
        static void Main(string[] args)
        {
            int size = 6;
            int[,] optimalCosts = new int[size, size];
            int[,] optimalDirections = new int[size, size];

            int[,] verticalCosts = new int[,]
            {
                { 1, 1, 1, 1, 1, 1 },
                { 1, 1, 1, 1, 1, 1 },
                { 1, 1, 1, 1, 1, 1 },
                { 1, 1, 1, 1, 1, 1 },
                { 1, 1, 1, 1, 1, 1 },
                { 1, 1, 1, 1, 1, 1 }
            };
            int[,] horizontalCosts = new int[,]
            {
                { 2, 2, 2, 2, 2, 2 },
                { 2, 2, 2, 2, 2, 2 },
                { 2, 2, 2, 2, 2, 2 },
                { 2, 2, 2, 2, 2, 2 },
                { 2, 2, 2, 2, 2, 2 },
                { 2, 2, 2, 2, 2, 2 }
            };

            FindPathsGreedy(optimalCosts, optimalDirections, verticalCosts, horizontalCosts);
            PrintMatrix(optimalDirections);
            Console.WriteLine();
            PrintMatrix(optimalCosts);

            Console.ReadLine();
        }

        static void PrintMatrix(int[,] matrix)
        {
            for (int row = 0; row < matrix.GetLength(0); row++)
            {
                for (int col = 0; col < matrix.GetLength(1); col++)
                {
                    Console.Write($"{matrix[row, col]}, ");
                }
                Console.WriteLine();
            }
        }

        static void FindPathsGreedy(int[,] oc, int[,] od, int[,] vc, int[,] hc)
        {
            int colMax = hc.GetLength(1);
            int row = vc.GetLength(0)-1;
            int col = 0;

            while (true)
            {
                int goUpCost;
                int goRightCost;
                if (row - 1 < 0 && col + 1 >= colMax)
                {
                    break;
                }
                else if (row - 1 >= 0 && col + 1 < colMax)
                {
                    goUpCost = vc[row - 1, col];
                    goRightCost = hc[row, col + 1];
                    if (goUpCost < goRightCost)
                    {
                        oc[row - 1, col] = oc[row, col] + goUpCost;
                        od[row - 1, col] = -1; // -1 means from below
                        row--;
                    }
                    else
                    {
                        oc[row, col + 1] = oc[row, col] + goRightCost;
                        od[row, col + 1] = 1; // 1 means from left
                        col++;
                    }
                }
                else if (row - 1 < 0)
                {
                    goRightCost = hc[row, col + 1];
                    oc[row, col + 1] = oc[row, col] + goRightCost;
                    od[row, col + 1] = 1; // 1 means from left
                    col++;
                }
                else if (col + 1 >= colMax)
                {
                    goUpCost = vc[row - 1, col];
                    oc[row - 1, col] = oc[row, col] + goUpCost;
                    od[row - 1, col] = -1; // -1 means from below
                    row--;
                }
            }
        }


    }
}